VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 1  'vbDataSource
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MySSS"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'  A suite of programs for the analysis of chants.
'  Copyright (C) 2000-2004 Ruth M. Ripley
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
Option Explicit
Private WithEvents MySS As ADODB.Recordset
Attribute MySS.VB_VarHelpID = -1
Private WithEvents MySX As ADODB.Recordset
Attribute MySX.VB_VarHelpID = -1
Private WithEvents mychants As ADODB.Recordset
Attribute mychants.VB_VarHelpID = -1

Public Property Get insertioncost(i) As Double
MySX.AbsolutePosition = i
insertioncost = MySX.Fields.Item("insertioncost").Value
End Property
Public Property Get sim(i, j) As Double
MySS.AbsolutePosition = i
sim = MySS.Fields.Item(NeumeTable(j)).Value
End Property
Private Sub Class_GetDataMember(DataMember As String, Data As Object)
Select Case DataMember
Case "SX"
    Set Data = MySX
Case "SS"
    Set Data = MySS
Case "ChantNames"
    Set Data = mychants
End Select
End Sub

Private Sub Class_Initialize()
Dim i As Integer, j As Integer
DataMembers.Add "SX"
DataMembers.Add "SS"
DataMembers.Add "ChantNames"

Set MySX = New ADODB.Recordset
With MySX
    .Fields.Append "neumeID", adBSTR, 255
    .Fields.Append "insertionCost", adDouble
    .CursorType = adOpenStatic
    .LockType = adLockOptimistic
    .Open
End With
For i = 1 To NumNeumes
    With MySX
        .AddNew
        .Fields.Item("neumeID") = NeumeTable(i)
        .Fields.Item("insertionCost") = SX(i)
        .Update
    End With
Next i
MySX.MoveFirst
Set MySS = New ADODB.Recordset
With MySS
    .Fields.Append "from neume", adBSTR, 255
    For j = 1 To NumNeumes
        .Fields.Append NeumeTable(j), adDouble
    Next j
    .CursorType = adOpenStatic
    .LockType = adLockOptimistic
    .Open
End With
For i = 1 To NumNeumes
    With MySS
        .AddNew
        .Fields.Item("from neume") = NeumeTable(i)
        For j = 1 To NumNeumes
        .Fields.Item(NeumeTable(j)) = SS(i, j)
        Next j
        .Update
    End With
Next i
MySS.MoveFirst
Set mychants = New ADODB.Recordset
With mychants
    .Fields.Append "Chant", adBSTR, 255
    .CursorType = adOpenStatic
    .LockType = adLockOptimistic
    .Open
End With
For i = 1 To NumChants
    With mychants
        .AddNew
        .Fields.Item("Chant") = Chants(i).FullName
        .Update
    End With
Next i
If NumChants > 0 Then
    mychants.MoveFirst
End If
End Sub

