Attribute VB_Name = "search"
'  A suite of programs for the analysis of chants.
'  Copyright (C) 2000-2004 Ruth M. Ripley
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
Option Base 1
Option Explicit

Public allmatc() As Variant, matched() As Boolean, sssFile As String
Public objSource As MySSS, chantsource As MySSS, Selected() As Boolean
Public D() As Double, a() As Variant, ascore() As Variant

Public request As String, narray() As Long, nlen() As Long, nchant() As Integer
Public nverse() As Integer, nphrase() As Integer, selcnt As Integer
Public Alignprt As report1, clusterPrt As report1, reprPrt As report1, matchPrt As report1
Public phrs() As String, z(2) As Variant, schant() As Integer, mystr() As String

Public SX() As Double, SS() As Double, SX1() As Double, SX2() As Double
Public sss() As Double, SST() As Long, SSSnew() As Double, SSTnew() As Long

Public r As StatConnector

Private Declare Sub computeS Lib "chantvb.dll" Alias "compS@56" _
(X As Long, Y As Long, ByVal nn As Long, ByVal mm As Long, _
ss1 As Double, S11 As Double, S10 As Long, _
SX As Double, ByVal sz As Long, ByVal ini As Long, _
ByVal metr As Long, jm As Long, im As Long, maxs As Double)

Private Declare Sub unravelc Lib "chantvb.dll" Alias "unravel@48" _
(ByVal ii As Long, ByVal jj As Long, mlen As Long, mtc As Long, musd As Long, _
endi As Long, endj As Long, ByVal s1 As Long, ByVal s2 As Long, _
S10 As Long, ByVal n As Long, ByVal m As Long)

Private Declare Sub recomputeSc Lib "chantvb.dll" Alias "recompS@72" _
(ByVal li As Long, ByVal lj As Long, seq1 As Long, seq2 As Long, mused As Long, _
ByVal localal As Long, ByVal n As Long, ByVal m As Long, _
S10 As Long, S11 As Double, SN10 As Long, SN As Double, _
SX As Double, ss1 As Double, ByVal sss As Long, jjm As Long, iim As Long, maxs As Double)
    
Public Sub do_stats()
Dim i As Integer, n As Integer
Dim cnt As Integer, j As Integer, k As Integer, l As Integer
Dim stt() As Integer, stp() As Integer, sno() As Integer, suse() As Boolean
Dim newsub As Integer, ii As Integer, zz As Variant
n = UBound(D)
If mdiform1.Align_all Or mdiform1.FreeEnd Then ' cluster directly if we can
    If n > 2 Then
        ReDim phrs(1 To n)
        For i = 1 To n
            phrs(i) = ""
            If mdiform1.Phrase Then
               phrs(i) = CStr(nverse(i)) & "/" & Chr(96 + nphrase(i))
            End If
            If mdiform1.Verse Then
                phrs(i) = CStr(nverse(i))
            End If
            If request = "" Then
                phrs(i) = Chants(nchant(i)).ShortName + "/" + phrs(i)
            End If
        Next i
        get_R D, phrs, z, request
    End If
Else ' subsequences
' try adding the numbers together - not very useful
'For i = 1 To n - 1
'    For j = i + 1 To n
'        If Not IsEmpty(a(i, j)) Then
'            For l = 2 To UBound(a(i, j))
'                D(i, j) = D(i, j) + ascore(i, j)(l)
'            Next l
'        End If
'    Next j
'Next i
'ReDim phrs(1 To n)
''For i = 1 To n
'    phrs(i) = CStr(i)
'Next i

'r.SetSymbol "d", D
'r.EvaluateNoReturn "save.image()"
'get_R D, phrs, z, "", mdiform1.ClusterLim.Value / 100
'Exit Sub
'cluster the matching subsequences found
    cnt = 0
    For i = 1 To n
        For j = i To n
            If Not IsEmpty(a(i, j)) Then
                cnt = cnt + UBound(a(i, j))
            End If
        Next j
    Next i
    If cnt = 0 Then
        MsgBox ("No matches found")
        Exit Sub
    End If
    ReDim sno(1 To 2 * cnt)
    ReDim stt(1 To 2 * cnt)
    ReDim stp(1 To 2 * cnt)
    ReDim suse(1 To 2 * cnt)
    k = 1
    For i = 1 To n
        For j = i To n
            If Not IsEmpty(a(i, j)) Then
                For l = 1 To UBound(a(i, j))
                    If i = j And l = 1 Then
                    Else
                        stt(k) = a(i, j)(l)(1, UBound(a(i, j)(l), 2))
                        stp(k) = a(i, j)(l)(1, 1)
                        sno(k) = nchant(i)
                        suse(k) = True
                        If stp(k) - stt(k) + 1 = UBound(a(i, j)(1), 2) Then
                            suse(k + 1) = False
                        Else
                            suse(k + 1) = True
                        End If
                        sno(k + 1) = nchant(j)
                        stt(k + 1) = a(i, j)(l)(2, UBound(a(i, j)(l), 2))
                        stp(k + 1) = a(i, j)(l)(2, 1)
                     '   Debug.Print a(i, j)(l)(1, 1), a(i, j)(l)(2, 1), _
                      '  a(i, j)(l)(2, UBound(a(i, j)(l)))
                        k = k + 2
                    End If
                Next l
            End If
        Next j
    Next i
    If k = 1 Then
        MsgBox ("No matches found")
    Exit Sub
    End If
    k = k - 1
    ReDim Preserve sno(1 To k)
    ReDim Preserve stt(1 To k)
    ReDim Preserve stp(1 To k)
    ReDim Preserve suse(1 To k)
    ' collapse list
    If k > 1 Then
        sort_R sno, stt, stp, zz, D
        newsub = 1
        For i = 0 To k - 1
            If zz(i) = 1 Then
                sno(newsub) = sno(i + 1)
                stt(newsub) = stt(i + 1)
                stp(newsub) = stp(i + 1)
                suse(newsub) = suse(i + 1)
                newsub = newsub + 1
            End If
        Next i
        k = newsub - 1
    End If
    ReDim nchant(1 To k)
    ReDim narray(1 To k)
    ReDim nlen(1 To k)
    ReDim phrs(1 To k)
    i = 0
    For ii = 1 To k
      '  If suse(ii) Then
            i = i + 1
            narray(i) = stt(ii) - 1
            nlen(i) = stp(ii) - stt(ii) + 1
            nchant(i) = sno(ii)
            phrs(i) = CStr(stt(ii)) & "-" & CStr(stp(ii))
            If request = "" Then
                phrs(i) = Chants(nchant(i)).ShortName + "/" + phrs(i)
            End If
       ' End If
    Next ii
    ReDim D(1 To i, 1 To i)
    ReDim Preserve nchant(1 To i)
    ReDim Preserve narray(1 To i)
    ReDim Preserve nlen(1 To i)
    ReDim Preserve phrs(1 To i)
    mdiform1.FreeEnd = True
    run_algorithm
    mdiform1.Subseq = True
' get representative sequences
    get_R D, phrs, z, request, mdiform1.ClusterLim.Value / 100
End If
End Sub




Public Sub get_sss()
Dim i As Integer, j As Integer, tmp As Double, ii As Integer
If objSource Is Nothing Then
    Exit Sub
End If
For i = 1 To NumNeumes
    SX(i) = objSource.insertioncost(i)
    'Debug.Print sx(i)
Next i
ii = 0
For i = 1 To NumNeumes
    For j = i To NumNeumes
        SS(i, j) = objSource.sim(i, j)
        tmp = objSource.sim(j, i)
        If tmp <> SS(i, j) Then
            ii = 1
     '   Debug.Print tmp, ss(i, j), i, j
        '    MsgBox ("non symmetric similarities - top one used")
        End If
        SS(j, i) = SS(i, j)
    Next j
Next i
If ii > 0 Then
MsgBox ("non symmetric similarities - top ones used")
End If
End Sub

Public Sub inseq(seq() As Long, len1 As Long, neum2() As Long, _
    len2 As Long, C2 As Integer, ep() As Boolean)
'search for seq1 in neum2, sets up matchlen, match arrays, returns match=t/f
Dim i As Long, j As Long, k As Integer, jj() As Integer
Dim m As Integer, imax As Long, jmax As Long, alldone As Boolean, cutoff As Single
Dim mlen As Long, matc() As Long, tmatc() As Variant
Dim msub As Integer, mused() As Long, maxs As Double, endi As Long, endj As Long
alldone = False
redims len1, len2
Call computeS(seq(1), neum2(1), len1, len2, SS(1, 1), sss(1, 1), SST(1, 1), _
SX(1), NumNeumes, 1, 2, jmax, imax, maxs)

cutoff = 0
For i = 1 To len1
    cutoff = cutoff + SX(seq(i))
Next i
cutoff = mdiform1.FindCutoff.Value / 100 * cutoff
If maxs < cutoff Then
    matched(C2) = False
    Exit Sub
End If
'have at least one match, probably
ReDim tmatc(len2) ' rather oversized
m = 1
msub = 0
ReDim mused(1 To len1, 1 To len2)
Do
'call unravel and fill matchlen and match arrays
    ReDim matc(1 To 2, 1 To 1000)
    'unravel i, j, mlen, matc, seq, neum2, mUsed, False, False, 0, 0
    Call unravelc(imax, jmax, mlen, matc(1, 1), mused(1, 1), _
    endi, endj, 0, 0, SST(1, 1), len1, len2)
    ReDim Preserve matc(1 To 2, 1 To mlen)
    If ep(jmax) Or mdiform1.MatchPhrases <> 1 Then
        tmatc(m) = matc
        m = m + 1
    End If
    'find next
    SSSnew = sss
    SSTnew = SST
    Call recomputeSc(endi, endj, seq(1), neum2(1), mused(1, 1), 0, _
    len1, len2, SST(1, 1), sss(1, 1), SSTnew(1, 1), SSSnew(1, 1), SX(1), _
    SS(1, 1), NumNeumes, jmax, imax, maxs)
    
    sss = SSSnew
    SST = SSTnew
Loop While maxs > 0 And maxs >= cutoff
If m > 1 Then
    matched(C2) = True
    ReDim Preserve tmatc(m - 1)
    allmatc(C2) = tmatc
End If
End Sub
Public Sub new_sss()
Set objSource = New MySSS
parms.DataGrid1.DataMember = "SX"
Set parms.DataGrid1.DataSource = objSource
parms.DataGrid2.DataMember = "SS"
Set parms.DataGrid2.DataSource = objSource
parms.Hide
parms.Show
mdiform1.MnuWCascade_Click
End Sub
Public Sub read_sss(fil As String)
Dim i As Integer, j As Integer, l As Integer
 Dim mymsg As String
ReDim SS(1 To NumNeumes, 1 To NumNeumes)
ReDim SX(1 To NumNeumes)
On Error GoTo Errhandler
Call Logfile(fil)
Open fil For Input As #1
For i = 1 To NumNeumes
    'sx(i) = Template(i).NumNotes
    Input #1, SX(i)
Next i
For i = 1 To NumNeumes
    For j = 1 To NumNeumes
     '   If i = j Then
     '   ss(i, j) = sx(i)
     '   Else
     '   ss(i, j) = -sx(i) - sx(j)
     '   End If
        Input #1, SS(i, j)
    Next j
Next i
Close #1
sssFile = fil
new_sss
'Unload parms
Exit Sub
Errhandler:
mymsg = "Parameter file length1.csv not found" + vbCr + "Similarities will be calculated from number of notes in neumes."
MsgBox mymsg
mdiform1.MnuCalcNbr_Click
End Sub


Private Sub redims(len1 As Long, len2 As Long)
    ReDim sss(1 To len1 + 1, 1 To len2 + 1)
    ReDim SST(1 To len1 + 1, 1 To len2 + 1)
    ReDim SX1(1 To len1)
    ReDim SX2(1 To len2)
End Sub


Public Sub write_sss(fil As String)
Dim i As Integer, j As Integer
Open fil For Output As #1
For i = 1 To NumNeumes
    Write #1, SX(i)
Next i
For i = 1 To NumNeumes
    For j = 1 To NumNeumes
        Write #1, SS(i, j);
    Next j
    Write #1,
Next i
Close #1
End Sub
Public Sub get_R(XX() As Double, phrs() As String, z() As Variant, _
ShortName As String, Optional lim As Double = 1)
Dim i As Integer, j As Integer, mystring As String

    If UBound(phrs) < 3 Then
        MsgBox ("not enough sequences to cluster")
        Exit Sub
    End If
    On Error GoTo error_handler
    
    r.SetSymbol "xx", XX
    r.SetSymbol "phr", phrs
    r.SetSymbol "shortname", ShortName
    r.SetSymbol "lim", lim
    mystring = "setwd('" + home_dir + "')"
    mystring = Replace(mystring, "\", "\\")
    Call Logfile(mystring)
    r.EvaluateNoReturn (mystring)
    r.EvaluateNoReturn ("save.image()")
    Call Logfile("after save")
    mystring = "mm" + ShortName
    mystring = Replace(mystring, " ", ".")
      r.EvaluateNoReturn (mystring + "<- cluslis(xx,phr,shortname,lim,returnall=TRUE)")
 Call Logfile("after clus")
 z(1) = 1
   z(2) = 1
    z(1) = r.Evaluate(mystring + "$arr")
    z(2) = r.Evaluate(mystring + "$arr2")
    r.EvaluateNoReturn ("save.image()")
    Exit Sub
error_handler:
   MsgBox r.GetErrorText, , "R Server Error Clustering"
End Sub
Public Sub sort_R(sno() As Integer, stt() As Integer, stp() As Integer, z As Variant, _
D() As Double)
    Dim i As Integer, j As Integer, mystring As String
    On Error GoTo error_handler

    r.SetSymbol "sno", sno
    r.SetSymbol "stt", stt
    r.SetSymbol "stp", stp
    r.SetSymbol "DD", D
   ' r.EvaluateNoReturn ("save.image()")
    z = r.Evaluate("ifelse(duplicated(paste(sno,stt,stp)),0,1)")
    Exit Sub
error_handler:
    MsgBox r.GetErrorText, , "R Server Error sort"
End Sub
Public Sub init_R()
    Dim mystring As String
    
    Set r = New StatConnector
    On Error GoTo error_handler
    r.init ("R")
    Call Logfile("app" + app_dir)
    mystring = "setwd('" + app_dir + "')"
    mystring = Replace(mystring, "\", "\\")
    Call Logfile(mystring)
    r.EvaluateNoReturn (mystring)
    r.EvaluateNoReturn ("source('cluslis.r')")
    'r.EvaluateNoReturn ("library(mva)")
    r.EvaluateNoReturn ("library(cluster)")
    Exit Sub
error_handler:
    MsgBox r.GetErrorText, , "R Server Error init"
End Sub
Public Sub close_R()
    On Error GoTo error_handler
    Dim mystring As String
    Dim z As Variant
    mystring = "setwd('" + home_dir + "')"
    mystring = Replace(mystring, "\", "\\")
    Call Logfile(mystring)
    z = r.Evaluate(mystring)
    Call Logfile("after setwd")
    r.EvaluateNoReturn ("save.image()")
    Call Logfile("after save")
    r.EvaluateNoReturn ("graphics.off()")
    Call Logfile("after graph off")
    r.Close
    Exit Sub
error_handler:
   MsgBox r.GetErrorText, , "R Server Error close"
End Sub

Public Sub split_sel()
Dim i As Integer, n As Integer, j As Integer, k As Integer, np As Integer
Dim m As Integer, newc As Chant2, jsub As Integer, nv As Integer
Dim cnt As Integer, nn As Integer
cnt = 0
If mdiform1.Verse Then
    n = 0
    For i = 1 To NumChants
        If Selected(i) Then
            cnt = cnt + 1
            request = Chants(i).ShortName
            nv = UBound(Chants(i).lenv)
            ReDim Preserve narray(1 To n + nv)
            ReDim Preserve nlen(1 To n + nv)
            ReDim Preserve nchant(1 To n + nv)
            ReDim Preserve nverse(1 To n + nv)
            For j = 1 To nv
                nchant(n + j) = i
                narray(n + j) = Chants(i).cnv(j - 1)
                nlen(n + j) = Chants(i).nnv(j)
                nverse(n + j) = j
            Next j
            n = n + nv
        End If
    Next i
ElseIf mdiform1.Phrase Then
    n = 0
    For i = 1 To NumChants
        If Selected(i) Then
            cnt = cnt + 1
            request = Chants(i).ShortName
            change_ds newc, i
            nv = UBound(Chants(i).lenv)
            np = 0
            For j = 1 To nv
                np = np + newc.Verse(j).NumPhrases
            Next j
            ReDim Preserve narray(1 To n + np)
            ReDim Preserve nlen(1 To n + np)
            ReDim Preserve nchant(1 To n + np)
            ReDim Preserve nverse(1 To n + np)
            ReDim Preserve nphrase(1 To n + np)
            jsub = 0
            For j = 1 To nv
                For k = 1 To newc.Verse(j).NumPhrases
                    nn = 0
                    For m = 1 To newc.Verse(j).Phrase(k).NumSyllables
                        nn = nn + newc.Verse(j).Phrase(k).Syllable(m).NumNeumes
                    Next m
                    jsub = jsub + 1
                    nchant(n + jsub) = i
                    narray(n + jsub) = newc.Verse(j).Phrase(k).NeumOffs
                    nlen(n + jsub) = nn
                    nverse(n + jsub) = j
                    nphrase(n + jsub) = k
                Next k
            Next j
            n = n + np
        End If
    Next i
ElseIf mdiform1.Chant Then
    n = 0
    ReDim Preserve narray(1 To NumChants)
    ReDim Preserve nlen(1 To NumChants)
    ReDim Preserve nchant(1 To NumChants)

    For i = 1 To NumChants
        If Selected(i) Then
            request = Chants(i).ShortName
            cnt = cnt + 1
            n = n + 1
            nchant(n) = i
            narray(n) = 0
            nlen(n) = Chants(i).cnv(UBound(Chants(i).lenv))
        End If
    Next i
    ReDim Preserve narray(1 To n)
    ReDim Preserve nlen(1 To n)
    ReDim Preserve nchant(1 To n)
End If
If cnt > 1 Then
    request = ""
End If
schant = nchant
'sverse = nverse
'sphrase = nphrase
ReDim mystr(1 To n)
For i = 1 To n
    If mdiform1.Phrase Then
       mystr(i) = "Verse " + CStr(nverse(i)) & "/" & "Phrase " + Chr(96 + nphrase(i))
    End If
    If mdiform1.Verse Then
        mystr(i) = "Verse " + CStr(nverse(i))
    End If
    If request = "" Then
        mystr(i) = Chants(nchant(i)).FullName + "/" + mystr(i)
    End If
Next i
End Sub
Public Sub run_algorithm()
Dim i As Integer, n As Integer, chi As Integer, chj As Integer
Dim aa() As Long
Dim ni As Long, nj As Long, li As Long, lj As Long, mused() As Long
Dim j As Integer, maxsim As Double, asc() As Variant, atmp() As Variant
Dim alen As Long, yy As Single, init As Integer, metric As Integer
Dim iimax As Long, jjmax As Long, endi As Long, endj As Long, maxs As Double, m As Integer
n = UBound(narray)
ReDim D(1 To n, 1 To n)
If mdiform1.Align_all Then
    init = 1
    metric = 0
ElseIf mdiform1.FreeEnd Then
    metric = 2
    init = 1
Else ' subseq
    init = 0
    metric = 1
    ReDim a(1 To n, 1 To n)
    ReDim ascore(1 To n, 1 To n)
End If
For i = 1 To n
    chi = nchant(i)
    ni = narray(i)
    li = nlen(i)
    For j = i To n
        chj = nchant(j)
        nj = narray(j)
        lj = nlen(j)
        redims li, lj
        Call computeS(Chants(chi).neum.names(ni + 1), _
            Chants(chj).neum.names(nj + 1), li, lj, _
            SS(1, 1), sss(1, 1), SST(1, 1), _
            SX(1), NumNeumes, init, metric, jjmax, iimax, maxsim)
        If Not (mdiform1.Align_all Or mdiform1.FreeEnd) Then
            ReDim atmp(100)
            ReDim asc(100)
            m = 0
            maxs = maxsim
            ReDim mused(1 To li, 1 To lj)
            Do While maxs >= mdiform1.SimilarCut.Value And m < 100
                m = m + 1
                asc(m) = maxs
                ReDim aa(1 To 2, 1 To 1000)
                Call unravelc(iimax, jjmax, alen, aa(1, 1), _
                mused(1, 1), endi, endj, _
                ni, nj, SST(1, 1), li, lj)
                SSTnew = SST
                SSSnew = sss
                Call recomputeSc(endi, endj, _
                    Chants(chi).neum.names(ni + 1), _
                    Chants(chj).neum.names(nj + 1), mused(1, 1), _
                    1, li, lj, SST(1, 1), sss(1, 1), SSTnew(1, 1), _
                    SSSnew(1, 1), SX(1), SS(1, 1), NumNeumes, _
                    jjmax, iimax, maxs)
                ReDim Preserve aa(1 To 2, 1 To alen)
                atmp(m) = aa
                sss = SSSnew
                SST = SSTnew
            Loop
            If m > 0 Then
                ReDim Preserve atmp(m)
                a(i, j) = atmp
                ascore(i, j) = asc
            Else
                Erase atmp
                a(i, j) = Empty
            End If
        End If
       ' If maxsim > 10 Or i = j Then
            D(i, j) = maxsim
        'Debug.Print maxsim, i, j
        'End If
    Next j
Next i
End Sub
Public Sub prt_aligned(dest As Object, text As String)
Dim i As Integer, j As Integer, yy As Single, n As Integer
Dim X As Single, newl As Boolean
If Not dest Is Printer Then
    dest.Cls
    dest.Caption = text
    dest.Show
Else
    dest.Print
    dest.Print
    dest.Print text
    dest.Print
    dest.Print
End If
yy = 300
n = UBound(a)
For i = 1 To n
    For j = i To n
        If Not IsEmpty(a(i, j)) Then
            prtCheck dest, False, X, yy, 1200, 500, newl, 0, 3000, 0
            dest.CurrentX = 0
            dest.CurrentY = yy - 300
            If (i <> j Or UBound(a(i, j)) > 1) Then
                dest.Print mystr(i); "  compared with  "; mystr(j)
                    'Chants(schant(j)).FullName
            End If
        '   Debug.Print Chants(schant(i)).FullName, Chants(schant(j)).FullName, i, j, yy, dest.Height
            chantpieces dest, yy, a(i, j), schant(i), schant(j), ascore(i, j), (i = j)
        End If
    Next j
Next i
If dest Is Printer Then
    dest.EndDoc
End If
End Sub

Public Sub chantpieces(dest As Object, Y As Single, a As Variant, C1 As Integer, C2 As Integer, _
asc As Variant, samev As Boolean)
Dim X As Single, k As Integer, mat As Integer, startno As Integer
Dim newl1 As Boolean, newl2 As Boolean, y2 As Single, incr As Integer
Dim used() As Boolean, first1 As Integer, first2 As Integer
'print set of pairs of matching bits of chant with text c1 and c2
'refer to the array a set up by the analysis routine
If C1 = C2 And samev Then
    startno = 2
    incr = 1
Else
    startno = 1
    incr = 1
End If
ReDim used(1 To UBound(Chants(C1).neum.names), 1 To UBound(Chants(C2).neum.names))
For mat = startno To UBound(a) Step incr
    first1 = a(mat)(1, UBound(a(mat), 2))
    first2 = a(mat)(2, UBound(a(mat), 2))
 '   Debug.Print first1, first2, used(first1, first2)
    If Not used(first1, first2) Then
       used(first1, first2) = True
       If startno = 2 Then
       used(first2, first1) = True
       End If
   '    Debug.Print used(first1, first2)
    X = 500
    newl1 = True
    newl2 = True
    If dest Is Printer And dest.CurrentY > 14800 Then
        dest.NewPage
        Y = 500
    End If
    dest.Print
    dest.CurrentY = Y
    dest.Print "Similarity score: "; asc(mat)
    dest.Print
    Y = dest.CurrentY
    For k = UBound(a(mat), 2) To 1 Step -1
        If a(mat)(1, k) > 0 Then
            If Chants(C1).neum.Nseq(a(mat)(1, k)) = 1 Or newl1 Then
                dest.CurrentY = Y + 250
                If newl1 Then
                    dest.CurrentX = 10
                    dest.Print Chants(C1).neum.NmSyl(a(mat)(1, k));
                End If
               ' Debug.Print X, dest.CurrentX, dest.Width, "cp", Chants(C1).Syllable(Chants(C1).Neum.NmSyl(a(mat)(1, k))).Text
                If X > dest.Width - 1000 Then
                    X = 400
                    Y = Y + 1300
                End If
                dest.CurrentX = X
                dest.CurrentY = Y + 250
                dest.Print Chants(C1).Syllable(Chants(C1).neum.NmSyl(a(mat)(1, k))).text
                If newl1 Then
                    dest.CurrentX = 10
                    dest.CurrentY = Y + 25
                    dest.Print a(mat)(1, k)
                    newl1 = False
                End If
                dest.CurrentX = X
            End If
            With Chants(C1).Syllable(Chants(C1).neum.NmSyl(a(mat)(1, k)))
                print_neume .Neume(Chants(C1).neum.Nseq(a(mat)(1, k))), _
                dest, X, Y, False, 1300
            End With
        End If
        If a(mat)(2, k) > 0 Then
            If Chants(C2).neum.Nseq(a(mat)(2, k)) = 1 Or newl2 Then
                dest.CurrentY = Y + 950
                If newl2 Then
                    dest.CurrentX = 10
                    dest.Print Chants(C2).neum.NmSyl(a(mat)(2, k));
                End If
                'Debug.Print X, dest.CurrentX, dest.Width, y, Chants(C2).Syllable(Chants(C2).Neum.NmSyl(a(mat)(2, k))).Text
                If X > dest.Width - 1000 Then
                    X = 400
                    Y = Y + 1300
                End If
                dest.CurrentX = X
                dest.CurrentY = Y + 850
                dest.Print Chants(C2).Syllable(Chants(C2).neum.NmSyl(a(mat)(2, k))).text
                If newl2 Then
                    dest.CurrentX = 10
                    dest.CurrentY = Y + 650
                    dest.Print a(mat)(2, k)
                    newl2 = False
                End If
                dest.CurrentX = X
            End If
            y2 = Y + 650
            With Chants(C2).Syllable(Chants(C2).neum.NmSyl(a(mat)(2, k)))
                print_neume .Neume(Chants(C2).neum.Nseq(a(mat)(2, k))), _
                dest, X, y2, False, 1300
            End With
            Y = y2 - 650
        End If
        X = X + 400
    Next k
    Y = Y + 1400
End If
Next mat
Y = Y + 100
End Sub
Public Sub clusterReport(dest As Object, z As Variant, _
    phrs() As String, ByVal myTitle As String)
Dim i As Integer, thisclust As Integer, Y As Single, j As Integer
Dim X As Single, newl As Boolean
If Not dest Is Printer Then
    dest.Cls
    dest.Caption = myTitle
    dest.Show
Else
    dest.Print myTitle
    dest.Print "============================"
    dest.Print
    dest.Print
End If
If dest Is Printer Then
    dest.FontName = "Helvetica"
End If
i = 0
If Not IsEmpty(z) Then
Do While i <= UBound(z)
    thisclust = z(i, 0)
    dest.CurrentX = 0
    prtCheck dest, False, X, Y, 600, 100, newl, 1000, 2600, 0
   ' Debug.Print "b", dest.CurrentY
    dest.Print "Group no: ", thisclust
    dest.Print
   ' Debug.Print "a", dest.CurrentY
    Do While thisclust = z(i, 0)
        dest.CurrentX = 0
        X = 0
       ' Debug.Print y, 2, dest.CurrentY
        
        prtCheck dest, False, X, Y, 600, 100, newl, 1000, 2600, 0
        dest.Print phrs(z(i, 1)); " height "; Round(z(i, 2), 2);
        Y = dest.CurrentY + 300
        X = 400
       ' Debug.Print y, 1, dest.CurrentY
    ' Debug.Print dest.CurrentY, dest.CurrentX
        For j = narray(z(i, 1)) + 1 To narray(z(i, 1)) + nlen(z(i, 1))
            print_neume_plus nchant(z(i, 1)), j, X, Y, dest, j = narray(z(i, 1)) + 1
            X = X + 400
        Next j
        dest.CurrentY = Y + 550
        i = i + 1
        If i > UBound(z) Then
            Exit Do
        End If
    Loop
Loop
End If
If dest Is Printer Then
    dest.EndDoc
End If
End Sub

Public Sub print_neume_plus(ByVal i As Integer, ByVal n As Integer, _
    X As Single, Y As Single, dest As Object, first As Boolean)
Dim seq As Integer, syl As Integer, newl As Boolean
prtCheck dest, False, X, Y, 600, 100, newl, 1500, 1400, 400
seq = Chants(i).neum.Nseq(n)
syl = Chants(i).neum.NmSyl(n)
If first Or newl Or seq = 1 Then
    dest.CurrentY = Y + 250
    If first Or newl Then
        dest.CurrentY = Y
        dest.CurrentX = 10
        dest.Print n;
        dest.CurrentX = 10
        dest.CurrentY = Y + 250
        dest.Print syl;
    End If
    dest.CurrentX = X
    dest.Print Chants(i).Syllable(syl).text;
End If
'Debug.Print seq, syl, first
print_neume Chants(i).Syllable(syl).Neume(seq), dest, X, Y, False, 600
End Sub
