VERSION 5.00
Begin VB.Form match 
   Caption         =   "Find Match"
   ClientHeight    =   3900
   ClientLeft      =   1008
   ClientTop       =   5616
   ClientWidth     =   4488
   LinkTopic       =   "Form1"
   ScaleHeight     =   4488
   ScaleMode       =   0  'User
   ScaleWidth      =   4608.889
   StartUpPosition =   1  'CenterOwner
   Begin VB.CommandButton OK 
      Caption         =   "OK"
      Height          =   492
      Left            =   3480
      TabIndex        =   2
      Top             =   960
      Width           =   732
   End
   Begin VB.PictureBox Picture1 
      Align           =   1  'Align Top
      AutoRedraw      =   -1  'True
      Height          =   588
      Left            =   0
      ScaleHeight     =   720
      ScaleMode       =   0  'User
      ScaleWidth      =   4440
      TabIndex        =   1
      Top             =   0
      Width           =   4488
   End
   Begin VB.ListBox NeumeList 
      Columns         =   2
      Height          =   2928
      Left            =   360
      TabIndex        =   0
      Top             =   840
      Width           =   2652
   End
   Begin VB.Menu MnuClear 
      Caption         =   "&Clear "
   End
   Begin VB.Menu MnuRedisplay 
      Caption         =   "&Redisplay"
   End
   Begin VB.Menu MnuInsert 
      Caption         =   "&Insert"
   End
   Begin VB.Menu MnuDelete 
      Caption         =   "&Delete"
   End
End
Attribute VB_Name = "match"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'  A suite of programs for the analysis of chants.
'  Copyright (C) 2000-2004 Ruth M. Ripley
'
'  This program is free software; you can redistribute it and/or modify
'  it under the terms of the GNU General Public License as published by
'  the Free Software Foundation; either version 2 of the License, or
'  (at your option) any later version.
'
'  This program is distributed in the hope that it will be useful,
'  but WITHOUT ANY WARRANTY; without even the implied warranty of
'  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'  GNU General Public License for more details.
'
'  You should have received a copy of the GNU General Public License
'  along with this program; if not, write to the Free Software
'  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
Option Base 1
Option Explicit
Private neumespatt As Boolean, currentneume As Integer, localpatt() As Neume

Private Sub display_neume(ByVal i As Integer)
print_neume localpatt(i), Picture1, 100 + 400 * (i - 1), 100, True, 600
End Sub

Private Sub Form_Load()
Dim i As Integer
'initialise list of neumes in listitem
NeumeList.Clear
For i = 1 To NumNeumes
    NeumeList.AddItem NeumeTable(i)
Next i
neumespatt = False
currentneume = 0
End Sub

Private Sub MnuClear_Click()
Erase localpatt
neumespatt = False
Picture1.Cls
End Sub

Private Sub MnuDelete_Click()
Dim i As Integer, neumelen As Integer
If Not neumespatt Or currentneume = 0 Then
    MsgBox ("Must select a neume first")
    Exit Sub
End If
neumelen = UBound(localpatt)
For i = currentneume To neumelen - 1
    localpatt(i) = localpatt(i + 1)
Next i
If neumelen > 1 Then
    ReDim Preserve localpatt(1 To neumelen - 1)
Else
    Erase localpatt
    neumespatt = False
    Picture1.Cls
End If
currentneume = 0
If neumespatt Then
    MnuRedisplay_Click
End If
End Sub

Private Sub MnuInsert_Click()
Dim neumelen As Integer, i As Integer
'put current selection in list before currentneume
If currentneume = 0 Or Not neumespatt Or NeumeList.ListIndex < 0 Then
    MsgBox ("Must select a position and neume first")
    Exit Sub
End If
neumelen = UBound(localpatt)
ReDim Preserve localpatt(1 To neumelen + 1)
For i = neumelen To currentneume Step -1
    localpatt(i + 1) = localpatt(i)
Next i
localpatt(currentneume) = Template(NeumeList.ListIndex + 1)
currentneume = 0
MnuRedisplay_Click
End Sub

Private Sub MnuRedisplay_Click()
Dim i As Integer
Picture1.Cls
Picture1.CurrentX = 100
For i = 1 To UBound(localpatt)
    display_neume (i)
Next i
End Sub

Private Sub NeumeList_DblClick()
Dim i As Integer, pos As Integer
'add a neume at end and display
If neumespatt Then
    ReDim Preserve localpatt(UBound(localpatt) + 1)
Else
    ReDim localpatt(1)
End If
pos = UBound(localpatt)
neumespatt = True
localpatt(pos) = Template(NeumeList.ListIndex + 1)
display_neume pos
End Sub

Private Sub OK_Click()
If neumespatt Then
    myneumes = localpatt
End If
neumepatt = neumespatt
Unload match
End Sub

Private Sub Picture1_MouseDown(Button As Integer, Shift As Integer, X As Single, y As Single)
Dim myx As Long, myy As Long
myx = (X - 100) / 400
If Not neumespatt Then
    Exit Sub
End If
If myx > UBound(localpatt) Then
    Exit Sub
End If
currentneume = myx + 1
myx = 100 + myx * 400
myy = 100
'draw coloured box on the screen
Picture1.DrawMode = vbInvert
Picture1.Line (myx, myy)-Step(350, 350), vbHighlight, BF
End Sub

